<?php

/**
 * Implementiert die Einstellung der Logging Parameter
 * @author Miguel Palmer <mp@beronet.com>
 */
class Logging {
	/**
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 * @return string HTML code
	 */

	function display() {
		require_once ('./includes/isgwtelnet.php');
		// args
		$m = $_GET['m'];

		$name = "LOGGING_TITLE_DIS";
		include('./includes/header.php');
		$general_table = $this->dynamic_table();
		// build page content
		$ret .= $general_table;
		return $ret;
	}

	/**
	 *@return string Die Adresse von dem Loging Server
	 */

	function address() {
		$ba = new beroAri();
		$logserver = $ba->get("logserver");
		$ret = explode(":", $logserver);
		return $ret[0];
	}

	/**
	 * @return string Syslog dropdown
	 */

	function syslog() {
		$ba = new beroAri();
		$option = $ba->get("syslog_facility");
		$sel = "<select name='syslog_facility' class='form-control input-sm'>";
		$j = 0;
		for ($i = 16; $i <= 23; $i++) {
			if ($option == $i)
				$sel .= '<option value=\'' . $i . '\' selected>' . $i . ' - local ' . $j++ . '</option>';
			else
				$sel .= '<option value=\'' . $i . '\'>' . $i . ' - local ' . $j++ . '</option>';
		}
		$sel .= "</select>";
		return $sel;
	}

	/**
	 * @param string $log Name für dropdown
	 * @return string Loglevel Dropdown
	 */

	function loglevel($log) {
		$ba = new beroAri();
		$loglevel = $ba->get($log);
		$ret .= "<select name='$log' class='form-control input-sm'>";
		($log == "loglevel_message") ? $j = 2 : $j = 9;
		for ($i = 0; $i <= $j; $i++) {
			($i == $loglevel) ? $selected = "selected" : $selected = "";
			$ret .= "<option value='$i' $selected>$i</option>";
		}
		$ret .= "</select>";
		return $ret;
	}

	/**
	 * @return int Das Port von dem Logserver
	 */

	function port() {
		$ba = new beroAri();
		$logserver = $ba->get("logserver");
		$ret = explode(":", $logserver);
		return $ret[1];
	}

	/**
	 * @param string Name für checkbox
	 * @return string Checkbox zum log aktivieren
	 */

	function active($log) {
		$ba = new beroAri();
		$active = $ba->get($log);
		$checked = ($active == "1") ?  "checked" : "";
		return "<input type='checkbox' name='$log' value='1' $checked>";
	}

	/**
	 * @param beroConf $bc
	 * @return string Checkbox enable system log
	 */

	function systemLog($bc) {
		$sysLog = $bc->get("root", "system-check-enabled");
		if ($sysLog == "1") {
			return "<input type='hidden' name='system-check-enabled' value='0'>"
			. "<input type='checkbox' name='system-check-enabled' value='1' checked>";
		} else {
			return "<input type='hidden' name='system-check-enabled' value='0'>"
			. "<input type='checkbox' name='system-check-enabled' value='1'>";
		}
	}

	/**
	 * Speichert die Änderung der Logging Einstellungen
	 * @param beroconf $bc
	 * @return string HTML code
	 */
	private function _save_logging($bc) {
		$ba = new beroAri();


		if (($_POST['address'] != "") && ($_POST['port'] != "")) {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->logserver($_POST['address'], $_POST['port']);
			$ba->set("logserver", sqlite_escape_string($_POST['address'] . ":" . $_POST['port']));
		}

		if ($_POST['loglevel_debug'] != "") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->loglevel($_POST['loglevel_debug']);
			$ba->set("loglevel_debug", sqlite_escape_string($_POST['loglevel_debug']));
		}
		if ($_POST['loglevel_message'] != "") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->loglevel_message($_POST['loglevel_message']);
			$ba->set("loglevel_message", sqlite_escape_string($_POST['loglevel_message']));
		}

		if ($_POST['logging_message'] == "1") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->logactive_message(1);
			$ba->set("logging_message", 1);
		} else {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->netlog(0);
			$isgw->logactive_message(0);
			$isgw->loglevel_message(0);
			$ba->set("logging_message", 0);
			$ba->set("loglevel_message", 0);
		}
		if ($_POST['logging_debug'] == "1") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->logactive(1);
			$ba->set("logging_debug", 1);
		} else {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->logactive(0);
			$isgw->loglevel(0);
			$ba->set("logging_debug", 0);
			$ba->set("loglevel_debug", 0);
		}
		if ($_POST['logging_message'] == "1" || $_POST['logging_debug'] == "1") {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->netlog(1);
			$ba->set("logging_active", 1);
		} else {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->netlog(0);
			$isgw->loglevel_message(0);
			$isgw->loglevel(0);
			$ba->set("logging_active", 0);
			$ba->set("loglevel_message", 0);
			$ba->set("loglevel_debug", 0);
		}

		if (isset($_POST['syslog_facility']) || isset($_POST['system-check-enabled'])) {
			//Nur wenn syslog facility verändert wurde, ist ein oranges activate erforderlich
			if ($ba->get('syslog_facility') != $_POST['syslog_facility'] || $bc->get("root", 'system-check-enabled') != $_POST['system-check-enabled']) {
				$table .= Helper::activate(2, true, $_GET['m'], ACTIVATE);
			}
			$ba->set("syslog_facility", sqlite_escape_string($_POST['syslog_facility']));
			$bc->set("root", "system-check-enabled", sqlite_escape_string($_POST['system-check-enabled']));
		} else {
			$ba->set("syslog_facility", "16");
			$table .= Helper::activate(2, true, $_GET['m'], ACTIVATE);
		}

		$table .= Helper::activate(1, true, $_GET['m'], ACTIVATE);
		return $table;
	}

	/**
	 * Generiert das Formular für die Logging Einstellungen
	 * @return string HTML Code
	 */

	function dynamic_table() {
		require_once('/usr/fallback/beroConf.php');
		$bc = new beroConf('root');
		//Logging Änderungen speichern
		if (isset($_POST['address']) || isset($_POST['ports']) || isset($_POST['syslog_facility'])) {
			$table .= $this->_save_logging($bc);
		}

		require_once("./includes/lang.php");
		ob_start();
		?>
		<form name='logging' id='logging' class="form-horizontal" action='' method='POST'>
			<input type=hidden name=m value='<? echo $m ?>'>
			<input type=hidden name=a value='save'>
			<br>
			<p class="text-center lead">
				<? echo LOGGING_TABLE_HEADER_DIS ?>
			</p>
			<div class='form-group' data-toggle='tooltip' title='<? echo GENERAL_ADDRESS; ?>'>
				<label for='address' class='col-sm-5 control-label'><? echo LOGGING_SERVER_DIS ?></label>
				<div class='col-sm-4'>
					<input type='text' class='form-control input-sm' name='address' value='<? echo $this->address() ?>'>
				</div>
			</div>
			<div class='form-group' data-toggle='tooltip' title='<? echo GENERAL_PORT; ?>'>
				<label for='port' class='col-sm-5 control-label'><? echo LOGGING_SERVER_PORT_DIS ?></label>
				<div class='col-sm-4'>
					<input type='text' class='form-control input-sm' name='port' value='<? echo $this->port() ?>'>
				</div>
			</div>
			<div class='form-group' data-toggle='tooltip' title='<? echo LOGGING_MESSAGE_ACTIVE; ?>'>
				<label for='logging_message' class='col-sm-5 control-label'><? echo LOGGING_MESSAGE_ACTIVE_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->active('logging_message') ?>
				</div>
			</div>
			<div class='form-group' data-toggle='tooltip' title='<? echo LOGGING_MESSAGE_LOGLEVEL; ?>'>
				<label for='loglevel_message' class='col-sm-5 control-label'><? echo LOGGING_MESSAGE_LEVEL_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->loglevel('loglevel_message') ?>
				</div>
			</div>
			<div class='form-group' data-toggle='tooltip' title='<? echo LOGGING_DEBUG_ACTIVE; ?>'>
				<label for='logging_debug' class='col-sm-5 control-label'><? echo LOGGING_DEBUG_ACTIVE_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->active('logging_debug') ?>
				</div>
			</div>
			<div class='form-group' data-toggle='tooltip' title='<? echo LOGGING_DEBUG_LOGLEVEL; ?>'>
				<label for='loglevel_debug' class='col-sm-5 control-label'><? echo LOGGING_DEBUG_LEVEL_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->loglevel('loglevel_debug') ?>
				</div>
			</div>
			<div class='form-group'>
				<label for='system-check-enabled' class='col-sm-5 control-label'><? echo LOGGING_SYSTEM_LOG_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->systemLog($bc) ?>
				</div>
			</div>
			<div class='form-group'>
				<label for='syslog_facility' class='col-sm-5 control-label'><? echo LOGGING_SYSLOG_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->syslog() ?>
				</div>
			</div>

			<br>
			<div class='text-center'>
				<input name='submit' type='submit' class='btn btn-default' value='<? echo BUTTON_SAVE ?>'>
			</div>
			<br>
		</form>
		<script>
		    $("#logging").validate({
		        rules: {
		            port: {
		                digits: true,
		                range: [1, 65535],
		            },
		        }
		    });
		</script>
		<?php
		$table .= ob_get_clean();

		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
		return $table;
	}

}
